﻿//Grading ID:S6945
//Program: Program 1
//Due Date:3/9/2020
//CIS 199-75 
//Spring 2020
// Desciption: The program is to help calculate tax-brackets for different plans. 
using System;
using static System.Console;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Program_2
{
    public partial class Programtwo : Form
    {
        public Programtwo()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //marginal tax rates
            //baseline
            const decimal BaseRate1 = .10m;//(lowest)
            const decimal BaseRate2 = .12m;
            const decimal BaseRate3 = .22m;
            const decimal BaseRate4 = .24m;
            const decimal BaseRate5 = .32m;
            const decimal BaseRate6 = .35m;
            const decimal BaseRate7 = .37m;//(highest)

            //Candidates 1 & 3
            const decimal C1_3_Rate1 = .10m;//(lowest)
            const decimal C1_3_Rate2 = .15m;
            const decimal C1_3_Rate3 = .25m;
            const decimal C1_3_Rate4 = .28m;
            const decimal C1_3_Rate5 = .33m;
            const decimal C1_3_Rate6 = .35m;
            const decimal C1_3_Rate7 = .396m;//(highest)

            //candidate 2
            const decimal C2_Rate1 = .10m;//(lowest)
            const decimal C2_Rate2 = .12m;
            const decimal C2_Rate3 = .22m;
            const decimal C2_Rate4 = .24m;
            const decimal C2_Rate5 = .32m;
            const decimal C2_Rate6 = .35m;
            const decimal C2_Rate7 = .40m;
            const decimal C2_Rate8 = .45m;
            const decimal C2_Rate9 = .50m;
            const decimal C2_Rate10 = .52m;//(highest)

            //Special Tax Circumstances
            const decimal C2_Extra_Rate = .04m; // candidate 2 Extra Tax Rate
            const decimal C2_Extra_Thresh = 29000;//candidate 2 Extra Tax Threshold
            const decimal C3_Reduction_Rate = .10m;//candidate 3 Reduction Tax Rate

            //Taxable income Thresholds for each candidate
            //Baseline
            const int Base_thresh1 = 9700;
            const int Base_thresh2 = 39_475;
            const int Base_thresh3= 84_200;
            const int Base_thresh4 = 160_725;
            const int Base_thresh5 = 204_100;
            const int Base_thresh6 = 510_300;
            //Candidate 1 & 3
            const int C1_3_Thresh1 = 9525;
            const int C1_3_Thresh2 = 38_700;
            const int C1_3_Thresh3 = 82_500;
            const int C1_3_Thresh4 = 157_500;
            const int C1_3_Thresh5 = 200_000;
            const int C1_3_Thresh6 = 500_000;
            //Candidate 2
            const int C2_Thresh1 = 9525;
            const int C2_Thresh2 = 38_700;
            const int C2_Thresh3 = 82_500;
            const int C2_Thresh4 = 157_500;
            const int C2_Thresh5 = 200_000;
            const int C2_Thresh6 = 250_000;
            const int C2_Thresh7 = 500_000;
            const int C2_Thresh8 = 2_000_000;
            const int C2_Thresh9 = 10_000_000;

            decimal currentTax;//tax accumulated from tresholds
            decimal tax=0;//tax calcuated within a threshold
            int income = int.Parse(incomeTxt.Text);//user inputs income in textbox
            decimal percent=0;//variable to help display percentages
            
            //If baseLine is clicked
            if (baseLineBtn.Checked)
            {
                //tier 1
                    currentTax = Math.Min(income, Base_thresh1) * BaseRate1;
                    tax += currentTax;
                    percent = BaseRate1;
                //tier 2
                 if (income > Base_thresh1)
                {
                    currentTax = Math.Min(income - Base_thresh1, Base_thresh2 - Base_thresh1)*BaseRate2;
                    tax += currentTax;
                    percent =BaseRate2;
                }
                //tier3
                if (income > Base_thresh2)
                {
                    currentTax = Math.Min(income - Base_thresh2, Base_thresh3 - Base_thresh2) * BaseRate3;
                    tax += currentTax;
                    percent = BaseRate3;
                }
                //tier4
                if (income > Base_thresh3)
                {
                    currentTax = Math.Min(income - Base_thresh3, Base_thresh4 - Base_thresh3) * BaseRate4;
                    tax += currentTax;
                    percent = BaseRate4;
                }
                //tier5
                if (income > Base_thresh4)
                {
                    currentTax = Math.Min(income - Base_thresh4, Base_thresh5 - Base_thresh4) * BaseRate5;
                    tax += currentTax;
                    percent = BaseRate5;
                }
                //tier6
                if (income > Base_thresh5)
                {
                    currentTax = Math.Min(income - Base_thresh5, Base_thresh6 - Base_thresh5) * BaseRate6;
                    tax += currentTax;
                    percent = BaseRate6;
                }
                //tier 7 (anything higher than $510,300)
                 if (income > Base_thresh6)
                {
                    currentTax = (income - Base_thresh6) * BaseRate7;
                    tax += currentTax;
                    percent = BaseRate7;
                }
            }

            if (canOneBtn.Checked)
            {
                //tier 1
                currentTax = Math.Min(income, C1_3_Thresh1) * C1_3_Rate1;
                tax += currentTax;
                percent = C1_3_Rate1;
                //tier 2
                if (income > C1_3_Thresh1)
                {
                    currentTax = Math.Min(income - C1_3_Thresh1, C1_3_Thresh2 - C1_3_Thresh1) * C1_3_Rate2;
                    tax += currentTax;
                    percent = C1_3_Rate2;
                }
                //tier3
                if (income > C1_3_Thresh2)
                {
                    currentTax = Math.Min(income - C1_3_Thresh2, C1_3_Thresh3 - C1_3_Thresh2) * C1_3_Rate3;
                    tax += currentTax;
                    percent = C1_3_Rate3;
                }
                //tier4
                if (income > C1_3_Thresh3)
                {
                    currentTax = Math.Min(income - C1_3_Thresh3, C1_3_Thresh4 - C1_3_Thresh3) * C1_3_Rate4;
                    tax += currentTax;
                    percent = C1_3_Rate4;
                }
                //tier5
                if (income > C1_3_Thresh4)
                {
                    currentTax = Math.Min(income - C1_3_Thresh4, C1_3_Thresh5 - C1_3_Thresh4) * C1_3_Rate5;
                    tax += currentTax;
                    percent = C1_3_Rate5;
                }
                //tier6
                if (income > C1_3_Thresh5)
                {
                    currentTax = Math.Min(income - C1_3_Thresh5, C1_3_Thresh6 - C1_3_Thresh5) * C1_3_Rate6;
                    tax += currentTax;
                    percent = C1_3_Rate6;
                }
                //tier7(anything higher than $500,000)
                if (income > C1_3_Thresh6)
                {
                    currentTax = (income - C1_3_Thresh6) * C1_3_Rate7;
                    tax += currentTax;
                    percent = C1_3_Rate7;
                }
                
            }

            if (canTwoBtn.Checked)
            {
                //tier 1
                currentTax = Math.Min(income, C2_Thresh1) * C2_Rate1;
                tax += currentTax;
                percent = C2_Rate1;
                //tier 2
                if (income > C2_Thresh1)
                {
                    currentTax = Math.Min(income - C2_Thresh1, C2_Thresh2 - C2_Thresh1) * C2_Rate2;
                    tax += currentTax;
                    percent = C2_Rate2;
                }

                //tier3
                if (income > C2_Thresh2)
                {
                    currentTax = Math.Min(income - C2_Thresh2, C2_Thresh3 - C2_Thresh2) * C2_Rate3;
                    tax += currentTax;
                    percent = C2_Rate3;
                }
                //tier4
                if (income > C1_3_Thresh3)
                {
                    currentTax = Math.Min(income - C2_Thresh3, C2_Thresh4 - C2_Thresh3) * C2_Rate4;
                    tax += currentTax;
                    percent = C2_Rate4;
                }
                //tier5
                if (income > C1_3_Thresh4)
                {
                    currentTax = Math.Min(income - C2_Thresh4, C2_Thresh5 - C2_Thresh4) * C2_Rate5;
                    tax += currentTax;
                    percent = C2_Rate5;
                }
                //tier6
                if (income > C2_Thresh5)
                {
                    currentTax = Math.Min(income - C2_Thresh5, C2_Thresh6 - C2_Thresh5) * C2_Rate6;
                    tax += currentTax;
                    percent = C2_Rate6;
                }
                //tier7
                if (income > C2_Thresh6)
                {
                    currentTax = Math.Min(income - C2_Thresh6, C2_Thresh7 - C2_Thresh6) * C2_Rate7;
                    tax += currentTax;
                    percent = C2_Rate7;
                }
                //tier8
                if (income > C2_Thresh7)
                {
                    currentTax = Math.Min(income - C2_Thresh7, C2_Thresh8 - C2_Thresh7) * C2_Rate8;
                    tax += currentTax;
                    percent = C2_Rate8;
                }
                //tier9
                if (income > C2_Thresh8)
                {
                    currentTax = Math.Min(income - C2_Thresh8, C2_Thresh9 - C2_Thresh8) * C2_Rate9;
                    tax += currentTax;
                    percent = C2_Rate9;
                }
                //tier 10 (Anything higher than $10,000,000)
                if (income > C2_Thresh9)
                {
                    currentTax = (income - C2_Thresh9) * C2_Rate10;
                    tax += currentTax;
                    percent = C2_Rate10;
                }
                //charge an extra 4% for income greater than $29,000
                if (income > C2_Extra_Thresh)
                {
                    currentTax = (income - C2_Extra_Thresh) * C2_Extra_Rate;
                    tax += currentTax;
                }
                

            }

            if (canThreeBtn.Checked)
            {
                //tier 1
                currentTax = Math.Min(income, C1_3_Thresh1) * C1_3_Rate1;
                tax += currentTax;
                percent = C1_3_Rate1;
                //tier 2
                if (income > C1_3_Thresh1)
                {
                    currentTax = Math.Min(income - C1_3_Thresh1, C1_3_Thresh2 - C1_3_Thresh1) * C1_3_Rate2;
                    tax += currentTax;
                    percent = C1_3_Rate2;
                }
                //tier3
                if (income > C1_3_Thresh2)
                {
                    currentTax = Math.Min(income - C1_3_Thresh2, C1_3_Thresh3 - C1_3_Thresh2) * C1_3_Rate3;
                    tax += currentTax;
                    percent = C1_3_Rate3;
                }
                //tier4
                if (income > C1_3_Thresh3)
                {
                    currentTax = Math.Min(income - C1_3_Thresh3, C1_3_Thresh4 - C1_3_Thresh3) * C1_3_Rate4;
                    tax += currentTax;
                    percent = C1_3_Rate4;
                }
                //tier5
                if (income > C1_3_Thresh4)
                {
                    currentTax = Math.Min(income - C1_3_Thresh4, C1_3_Thresh5 - C1_3_Thresh4) * C1_3_Rate5;
                    tax += currentTax;
                    percent = C1_3_Rate5;
                }
                
                //A criteria setup for a 10% reduction for income earned up to $200,000 
                    currentTax = tax * C3_Reduction_Rate;//takes accumulated running total tax at this momment and multiplies it by 10%.
                    tax -= currentTax;//then it takes that amount from the currentTax variable and subtracts it from the tax variable.

                //tier6
                if (income > C1_3_Thresh5)
                {
                    currentTax = Math.Min(income - C1_3_Thresh5, C1_3_Thresh6 - C1_3_Thresh5) * C1_3_Rate6;
                    tax += currentTax;
                    percent = C1_3_Rate6;
                }

                //tier7
                if (income > C1_3_Thresh6)
                {
                    currentTax = (income - C1_3_Thresh6) * C1_3_Rate7;
                    tax += currentTax;
                    percent = C1_3_Rate7;
                }
               
                   
                
            }

            incomeTaxLbl.Text = $"{tax:n2}";//displays incometax owed
            taxPercentLbl.Text = $"{percent:p}";//displays tax percentage

           



        }    
    }
}
